...
from bigboard.libbig.http import AsyncHTTPFetcherWithAuth

FAILED_TO_LOGIN_STRING = "Failed to login."

class TwitterStock(Stock):

    def __init__(self, *args, **kwargs):
        ...
        self.__fetcher = AsyncHTTPFetcherWithAuth()

    ...

    def __on_twitter_account_changed(self):
        _logger.debug("will change stuff")
        username = self.__twitter_account.GetUsername()
        password = self.__twitter_account.GetPassword() 
        if password != "":
            self.__box.remove_all()
            checking = hippo.CanvasText(text="Checking credentials for " + username + "...",
                                          size_mode=hippo.CANVAS_SIZE_WRAP_WORD, classes="info")
            self.__box.append(checking)
            self.__fetcher.fetch("http://twitter.com/account/verify_credentials.json", 
                                 username, password,
                                 lambda url, data: self.__on_twitter_response(url, data, username, password), 
                                 lambda url, resp: self.__on_twitter_error(url, resp, username, password),
                                 lambda url: self.__on_auth_failed(username, password),
                                 data = urllib.urlencode({}))
        else:
            self.__add_login_button()  

    def __on_twitter_response(self, url, data, username, password):
        _logger.debug("Authentication must be good")
        if self.__same_credentials(username, password):
            self.__box.remove_all()
            hello_message = hippo.CanvasText(text="Hello Twitter User " + self.__twitter_account.GetUsername() ,
                                             size_mode=hippo.CANVAS_SIZE_WRAP_WORD)
            self.__box.append(hello_message)

    def __on_twitter_error(self, url, resp, username, password):
        status = resp and str(resp.status) or "No response"
        _logger.debug("There was a Twitter error. Response: %s" % status)
        if self.__same_credentials(username, password):
            self.__add_login_button(True)

    def __on_auth_failed(self, username, password):
        _logger.debug("There was an authentication failure")
        if self.__same_credentials(username, password):
            self.__add_login_button(True)

    def __same_credentials(self, username, password):
        return self.__twitter_account and self.__twitter_account.GetUsername() == username and self.__twitter_account.GetPassword() == password

    def __add_login_button(self, failed_to_login = False):
        self.__box.remove_all()
        if failed_to_login:
            error = hippo.CanvasText(text=FAILED_TO_LOGIN_STRING, size_mode=hippo.CANVAS_SIZE_WRAP_WORD, classes="error")
            self.__box.append(error) 
        hello_message = hippo.CanvasText(text="Hello Twitter User " + self.__twitter_account.GetUsername(),
                                         size_mode=hippo.CANVAS_SIZE_WRAP_WORD)
        self.__box.append(hello_message)                           
        self.__box.append(self.__login_button) 


FROM stock.css:

.info {
    color: #00AABB;
}

.error {
    color: #CC1122;
}
